'  FormClass 
    
' : "Set WebForm = New WebFormClass" 
    
'Form.Action             '  - URL     . (/) 
'Form.AddField           '  -  . 
'Form.AddFile            '  -  . 
'Form.Boundary           '  -    () 
'Form.Enctype            '  -    (   - "application/x-www-form-urlencoded".      - "multipart/form-data") (/) 
'Form.Method             '  -    (GET / POST) 
'Form.VarBody            '  -     (/) 

'     http://www.zalil.ru 
    
Dim WebForm 
'///     
Set WebForm = New WebFormClass 
'///      
WebForm.Action = "http://www.zalil.ru/upload/" 
'///    POST 
WebForm.Method = "POST" 
'///         multipart/form-data 
WebForm.Enctype = "multipart/form-data" 
'///   
WebForm.AddFile "file", "C:\boot.ini" 
'///        
Submit WebForm

Sub Submit(WebForm) 
    '///     
    Dim XMLHTTP 
    Set XMLHTTP = CreateObject("MSXML2.XMLHTTP") 
    '///    URL 
    XMLHTTP.Open WebForm.Method, WebForm.Action, False 
    '///     POST,      
    If WebForm.Method = "POST" Then 
        '///     "multipart/form-data",       
        If WebForm.Enctype = "multipart/form-data" Then 
            XMLHTTP.setrequestheader "Content-type", WebForm.Enctype & "; boundary=" & WebForm.Boundary 
        Else '///       ,     
            XMLHTTP.setrequestheader "Content-type", WebForm.Enctype 
        End If 
    End If 
    
    '///   
    XMLHTTP.Send WebForm.VarBody 
    '///    
    Select Case XMLHTTP.Status 
    '///  200 - OK.    
    Case 200 
        Dim InternetExplorer 
        Set InternetExplorer = CreateObject("InternetExplorer.Application") 
        InternetExplorer.Visible = True 
        InternetExplorer.Navigate "about:blank" 
        Do 
                        WScript.Sleep 100 
        Loop Until InternetExplorer.readystate = 4 
        InternetExplorer.document.write XMLHTTP.responsetext 
    Case Else 
        MsgBox XMLHTTP.Status & " " & StatusText, vbCritical, "    !" 
    End Select 
End Sub 


'///   
Class WebFormClass 
        Private Fields, Files 
        Private PropertyEnctype, PropertyMethod, PropertyBoundary, PropertyAction 

        Private Sub Class_Initialize() 
            Fields = Array() 
            Files = Array() 
            PropertyEnctype = "application/x-www-form-urlencoded" 
            PropertyMethod = "GET" 
            PropertyBoundary = String(27, "-") & GenerateBoundary 
            PropertyAction = "about:blank" 
        End Sub 

        Public Property Let Action(Value) 
            PropertyAction = Value 
        End Property 

        Public Property Get Action() 
            Action = PropertyAction 
            If PropertyMethod = "GET" Then 
                Dim Params 
                Params = VarBody 
                If VarBody <> "" Then Action = Action & "?" & Params 
            End If 
        End Property 

        Public Property Get Boundary() 
            Boundary = PropertyBoundary 
        End Property 

        Public Property Get Method() 
            Method = PropertyMethod 
        End Property 

        Public Property Let Method(Value) 
            Value = UCase(Value) 
            If Value = "GET" Or Value = "POST" Then PropertyMethod = Value 
        End Property 

        Public Property Get Enctype() 
            Enctype = PropertyEnctype 
        End Property 

        Public Property Let Enctype(Value) 
            Value = LCase(Value) 
            If Value = "multipart/form-data" Or Value = "application/x-www-form-urlencoded" Then PropertyEnctype = Value 
        End Property 

        Public Sub AddField(Name, Value) 
            SetElement Fields, Name, Value 
        End Sub 

        Public Sub AddFile(Name, Value) 
            SetElement Files, Name, Value 
        End Sub 

        Private Function SetElement(ArrayRef, Name, Value) 
            For ElementID = 0 To UBound(ArrayRef) 
                If ArrayRef(ElementID)(0) = Name Then 
                    ArrayRef(ElementID)(1) = Value 
                    Exit Function 
                End If 
            Next 
            ReDim Preserve ArrayRef(UBound(ArrayRef) + 1) 
            ArrayRef(UBound(ArrayRef)) = Array(Name, Value) 
        End Function 
          

        Public Property Get VarBody() 
            If PropertyMethod = "POST" And PropertyEnctype = "multipart/form-data" Then 
                Const DefaultBoundary = "--" 
                Dim Stream 
                Set Stream = CreateObject("ADODB.Stream") 
                Stream.Type = 2 
                Stream.Mode = 3 
                Stream.Charset = "Windows-1251" 
                Stream.Open 
                
                Dim FieldHeader, FieldsBody 
                
                For Each Field In Fields 
                    FieldHeader = "Content-Disposition: form-data; name=""" & Field(0) & """" 
                    FieldsBody = FieldsBody & DefaultBoundary & PropertyBoundary & vbCrLf & FieldHeader & vbCrLf & Field(1) & vbCrLf 
                Next 
                
                Stream.WriteText FieldsBody 
                
                Dim FileHeader 
                
                For Each File In Files 
                    If LoadFile(File(1), Data) Then 
                        FileHeader = DefaultBoundary & Boundary & vbCrLf & "Content-Disposition: form-data; name=""" & File(0) & """; filename=""" & File(1) & """" & vbCrLf & "Content-Type: octet/stream" & vbCrLf & vbCrLf 
                        Stream.WriteText FileHeader 
                        Stream.Position = 0 
                        Stream.Type = 1 
                        Stream.Position = Stream.Size 
                        Stream.write Data 
                        Stream.Position = 0 
                        Stream.Type = 2 
                        Stream.Position = Stream.Size 
                    End If 
                Next 
                
                Stream.Position = 0 
                Stream.Type = 2 
                Stream.Position = Stream.Size 
                Stream.WriteText vbCrLf & DefaultBoundary & PropertyBoundary & DefaultBoundary 
                
                Stream.Position = 0 
                Stream.Type = 1 
                
                VarBody = Stream.Read 
            Else 
                For Each Field In Fields 
                    VarBody = VarBody & Escape(Field(0)) & "=" & Escape(Field(1)) & "&" 
                Next 
                For Each File In Files 
                    VarBody = VarBody & Escape(File(0)) & "=" & Escape(File(1)) & "&" 
                Next 
                if Len(VarBody) > 0 Then VarBody = Left(VarBody, Len(VarBody) - 1) 
            End If 
        End Property 

        Private Function LoadFile(Path, Data) 
            On Error Resume Next 
            Dim Stream 
            Set Stream = CreateObject("ADODB.Stream") 
            Stream.Type = 1 
            Stream.Mode = 3 
            Stream.Open 
            Stream.LoadFromFile Path 
            If Err.Number <> 0 Then Exit Function 
            Data = Stream.Read 
            LoadFile = True 
        End Function 

        Private Function GenerateBoundary() 
            Dim Char 
            Dim N 
            For N = 1 To 12 
                Randomize 
                Char = Chr(CLng(Rnd * 25) + 97) 
                If N Mod 2 Then Char = UCase(Char) 
                GenerateBoundary = GenerateBoundary & Char 
            Next 
        End Function 
End Class